#!/usr/bin/perl -w 

$| = 1;

use strict;
use CGI::Carp qw(fatalsToBrowser);
use CGI;
use Text::CSV_XS;
use Date::Parse;
use POSIX;
require "../survey.pm";

our $dbh = db_connect();
our $cgi = CGI->new();

if($cgi->param('action') eq 'download')
{
  my $csv = Text::CSV_XS->new({ binary => '1'});

  my $survey_id = $cgi->param('survey_id');

#  print $cgi->header();
  print $cgi->header(-type=>'x-application/unknown',
                     -attachment => "$survey_id.csv");

  my @qs = dbi_exec_for_column_list($dbh, q|SELECT DISTINCT(question_id) FROM survey_data JOIN survey_responses ON survey_data.sr_id = survey_responses.id WHERE survey_id = ?|, $survey_id);

  my @cols = ('survey_id', 'taker_email', @qs, 'timestamp');
  $csv->combine(@cols);
  print $csv->string() . "\r\n";
  my $sth = $dbh->prepare("SELECT survey_responses.id as sr_id, survey_responses.create_date, email FROM survey_responses JOIN survey_takers ON survey_responses.taker_id = survey_takers.id WHERE survey_id = ?");
  $sth->execute($survey_id);

  while(my $sr_row = $sth->fetchrow_hashref()) 
  {
    my @row = ($survey_id, $sr_row->{email}); 
    my $sd_sth = $dbh->prepare("SELECT question_id, text FROM survey_data WHERE sr_id = ?");
    $sd_sth->execute($sr_row->{sr_id});

    my %data;
    while (my $sd_row = $sd_sth->fetchrow_hashref) 
    {
      $sd_row->{text} =~ s/\r//g;
      $sd_row->{text} =~ s/\n//g;
      $data{$sd_row->{question_id}} = $sd_row->{text};
    }
    $sd_sth->finish;

    foreach my $q (@qs) 
    {
      push @row, $data{$q};
    }
    push(@row, $sr_row->{create_date});

    $csv->combine(@row);
    print $csv->string() . "\r\n";
    undef %data;
    undef @row;
  }
#  return 0;
}
else
{
  print $cgi->header();
  print $cgi->start_html('Survey Admin');
  print $cgi->start_form(-method=>'GET');
  print "<input type=hidden name=action value=download>\n";
  print qq/Pick a survey to download: <SELECT NAME="survey_id">/;

  foreach my $survey_id (dbi_exec_for_column_list($dbh, q/select distinct(survey_id) from survey_responses/))
  {
    print qq/<OPTION VALUE="$survey_id">$survey_id/;
  }
  print qq|</SELECT>\n|;

  print qq|<input type="submit" name=submit value=Download>|;
  print $cgi->end_form();
  print $cgi->end_html();
}
