#!/usr/bin/perl -w

$| = 1;

use strict;

use CGI::Carp qw(fatalsToBrowser);
use CGI;
use Email::Valid;
use DBI;
use survey;

our $dbh = db_connect();
our $cgi = CGI->new();

my $params = params_hash($cgi);

my @all_qs = grep(/^Q(.)?_.+/, keys(%{$params}));

my @required_qs = grep(/^QR_.+/, @all_qs);
my @optional_qs = grep(/Q_.+/, @all_qs);

my $error = '';

die "missing survey_id" unless($params->{survey_id});

foreach (@required_qs) 
{
  $error = 1 unless (defined($params->{$_}) && $params->{$_} ne '');
}

$error = 1 unless(Email::Valid->address($cgi->param('email')));

if($error)
{
  print $cgi->redirect('error.html');
  exit;
}
else
{
print $cgi->header();
#foreach (@args) {
#  print "$_ : " . $cgi->param($_) . "<br>\n";
#}

  my $taker_id = add_taker($params->{email});
  save_response($params->{survey_id}, $taker_id, \@all_qs);

  print "Added $params->{email} / $taker_id";
  
#  print $cgi->redirect('thanks.html');

  cleanup($dbh);
}

sub save_response
{
  my $survey_id = shift(@_);
  my $taker_id = shift(@_);
  my $all_qs = shift(@_);

  # if the take has already entered survey data for this survey, deleted and 
  # add it back in.  No need for dups.
  my $sr_id = dbi_exec_for_scalar($dbh, "SELECT id FROM survey_responses WHERE taker_id = ? AND survey_id = ?", $taker_id, $survey_id); 

  if($sr_id)
  {
    $dbh->do("DELETE FROM survey_data WHERE sr_id = ?", {}, $sr_id); 
    $dbh->do("DELETE FROM survey_responses WHERE taker_id = ? AND survey_id = ?", {}, $taker_id, $survey_id); 
  }

  $dbh->do("INSERT INTO survey_responses (taker_id, survey_id) VALUES(?, ?)", {}, $taker_id, $survey_id);

  $sr_id = dbi_exec_for_scalar($dbh, "SELECT id FROM survey_responses WHERE taker_id = ? AND survey_id = ?", $taker_id, $survey_id); 

  foreach (@{$all_qs})
  {
    $dbh->do("INSERT INTO survey_data (sr_id, question_id, text) VALUES(?, ?, ?)", {}, $sr_id, $_, $params->{$_}); 
  }
}

sub add_taker
{
  my $email = shift;
  
  my $taker_id = dbi_exec_for_scalar($dbh, "select id from survey_takers where email = ?", $email);
  
  return $taker_id if($taker_id);

  $dbh->do("insert into survey_takers (email) values(?)", {}, $email);
  return(dbi_exec_for_scalar($dbh, "select id from survey_takers where email = ?", $email));
}
